From 6ccbcc22e4c19183a7c90f3312cdf3fa788920a9 Mon Sep 17 00:00:00 2001
From: Lukas Brabec <lbrabec@redhat.com>
Date: May 10 2018 11:24:02 +0000
Subject: [PATCH 1/7] variables for env matching added


Playbooks can now contain these variables for
devise_environment function:
- taskotron_match_host_distro
- taskotron_match_host_release
- taskotron_match_host_arch
If not present, values default to False and default
env/{distro,release,arch} is used instead.

---

diff --git a/libtaskotron/executor.py b/libtaskotron/executor.py
index e1d6934..bbdcb6a 100644
--- a/libtaskotron/executor.py
+++ b/libtaskotron/executor.py
@@ -28,6 +28,34 @@ except ImportError as e:
     raise exc.TaskotronImportError(e)
 
 
+class Playbook_Data(object):
+    '''Class holding parsed variables from playbook'''
+    def __init__(self, playbook={}):
+        self.match_host_distro = playbook.get('vars', {}).get(
+            'taskotron_match_host_distro', False)
+        log.info("Variable taskotron_match_host_distro is %s", self.match_host_distro)
+
+        self.match_host_release = playbook.get('vars', {}).get(
+            'taskotron_match_host_release', False)
+        log.info("Variable taskotron_match_host_release is %s", self.match_host_release)
+
+        self.match_host_arch = playbook.get('vars', {}).get(
+            'taskotron_match_host_arch', False)
+        log.info("Variable taskotron_match_host_arch is %s", self.match_host_arch)
+
+        if playbook.get('vars',{}).get('taskotron_generic_task', False):
+            self.generic = True
+            self.exec_tasks = 'tasks_generic.yml'
+        else:
+            self.generic = False
+            self.exec_tasks = 'tasks_sti.yml'
+        log.info('Variable taskotron_generic_task is: %s', self.generic)
+
+        self.keepalive = playbook.get('vars', {}).get(
+            'taskotron_keepalive_minutes', None)
+        log.info('Variable taskotron_keepalive_minutes is: %s', self.keepalive)
+
+
 class Executor(object):
     '''Executor executes given task in the format of Ansible playbook. Before
     actual execution, executor decides where the playbook will be executed
@@ -45,15 +73,17 @@ class Executor(object):
         self.task_vm = None
         self.run_remotely = False
 
-    def _spawn_vm(self, uuid):
+    def _spawn_vm(self, uuid, playbook_data):
         '''Spawn a virtual machine using testcloud.
 
         :param str uuid: unicode string uuid for the task being executed
+        :param playbook_data: instance of Playbook_Data with parsed vars from
+                              playbook
         :returns: str ip address of spawned vm
         '''
         log.info('Spawning disposable client')
 
-        env = image_utils.devise_environment(self.arg_data)
+        env = image_utils.devise_environment(self.arg_data, playbook_data)
         self.task_vm = vm.TestCloudMachine(uuid)
 
         retries = config.get_config().spawn_vm_retries
@@ -137,13 +167,15 @@ class Executor(object):
                       e)
             raise exc.TaskotronPlaybookError(e)
 
-    def _run_playbook(self, test_playbook, ipaddr, root=True):
+    def _run_playbook(self, test_playbook, ipaddr, playbook_data, root=True):
         '''Run the ansible-playbook command to execute given playbook
         containing the task.
 
         :param str test_playbook: name of the playbook, relative to the task
             directory
         :param str ipaddr: IP address of the machine the task will be run on
+        :param playbook_data: instance of Playbook_Data with parsed vars from
+                              playbook
         :param bool root: whether to run as ``root`` for local execution mode
         :return: a tuple of ``(str, bool)``. The first item is stream output of
             the ansible-playbook command (stdout and stderr merged together).
@@ -174,25 +206,6 @@ class Executor(object):
 
         minion_repos = config.get_config().minion_repos
 
-        # load taskotron vars from playbook and compute variables
-        with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
-            as playbook_file:
-            # playbook should contain at least one play as the file passed the
-            # syntax check
-            # TODO: should we look for 'taskotron_generic_task' in all plays,
-            # not just in the first?
-            playbook = yaml.load(playbook_file.read())[0]
-            if playbook.get('vars',{}).get('taskotron_generic_task', False):
-                generic = True
-                exec_tasks = 'tasks_generic.yml'
-                log.debug('Playbook %s is a generic task', test_playbook)
-            else:
-                generic = False
-                exec_tasks = 'tasks_sti.yml'
-                log.debug('Playbook %s is an STI task', test_playbook)
-            keepalive = playbook.get('vars', {}).get(
-                'taskotron_keepalive_minutes', None)
-
         # set up variables to load into playbooks.
         # separate them into the ones to forward, and the ones to use
         # internally
@@ -213,7 +226,7 @@ class Executor(object):
         ansible_vars_internal = {
             'artifacts_root': self.arg_data['artifactsdir'],
             'client_taskdir': config.get_config().client_taskdir,
-            'exec_tasks': exec_tasks,
+            'exec_tasks': playbook_data.exec_tasks,
             'minion_repos': minion_repos,
             'taskdir': self.arg_data['taskdir'],
             'test_playbook': test_playbook,
@@ -223,8 +236,8 @@ class Executor(object):
         varsfile_internal = os.path.join(artifacts_subdir, 'taskotron',
                                          'ansible_vars_internal.json')
 
-        if keepalive:
-            ansible_vars_internal['keepalive_minutes'] = keepalive
+        if playbook_data.keepalive:
+            ansible_vars_internal['keepalive_minutes'] = playbook_data.keepalive
 
         # figure out the ansible-playbook command
         cmd = [
@@ -271,7 +284,7 @@ class Executor(object):
             signal.signal(signal.SIGTERM, self._interrupt_handler)
 
             output, _ = os_utils.popen_rt(cmd, cwd=ansible_dir)
-            return (output, generic)
+            return (output, playbook_data.generic)
         except subprocess.CalledProcessError as e:
             log.error('ansible-playbook ended with %d return code',
                       e.returncode)
@@ -340,14 +353,19 @@ class Executor(object):
 
         failed = []
         for test_playbook in test_playbooks:
+            with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
+            as playbook_file:
+                playbook_yaml = yaml.load(playbook_file.read())[0]
+                playbook_data = Playbook_Data(playbook_yaml)
+
             ipaddr = self._get_client_ipaddr()
             if ipaddr is None:
-                ipaddr = self._spawn_vm(self.arg_data['uuid'])
+                ipaddr = self._spawn_vm(self.arg_data['uuid'], playbook_data)
 
             log.info('Running playbook %s on machine: %s', test_playbook, ipaddr)
 
             try:
-                _, generic = self._run_playbook(test_playbook, ipaddr)
+                _, generic = self._run_playbook(test_playbook, ipaddr, playbook_data)
                 if generic:
                     self._report_results(test_playbook)
             except exc.TaskotronInterruptError as e:
diff --git a/libtaskotron/ext/disposable/vm.py b/libtaskotron/ext/disposable/vm.py
index a790fe6..9d443ff 100644
--- a/libtaskotron/ext/disposable/vm.py
+++ b/libtaskotron/ext/disposable/vm.py
@@ -62,11 +62,6 @@ class TestCloudMachine(object):
             if config.get_config().force_imageurl:
                 img_url = config.get_config().imageurl
             else:
-                distro = distro or config.get_config().default_disposable_distro
-                release = release or config.get_config().default_disposable_release
-                flavor = flavor or config.get_config().default_disposable_flavor
-                arch = arch or config.get_config().default_disposable_arch
-
                 log.debug("Looking for image with DISTRO: %s, RELEASE: %s, FLAVOR: %s, ARCH: %s" %
                           (distro, release, flavor, arch))
 
diff --git a/libtaskotron/image_utils.py b/libtaskotron/image_utils.py
index 01f21b8..5608ce0 100644
--- a/libtaskotron/image_utils.py
+++ b/libtaskotron/image_utils.py
@@ -9,6 +9,7 @@ import re
 
 from libtaskotron import exceptions as exc
 from libtaskotron.logger import log
+from libtaskotron import config
 
 try:
     from libtaskotron.ext.fedora import rpm_utils
@@ -16,13 +17,14 @@ except ImportError as e:
     raise exc.TaskotronImportError(e)
 
 
-def devise_environment(arg_data):
+def devise_environment(arg_data, playbook_data):
     '''Takes an input item and type, and returns a required run-environment (i.e.
     distro, arch, fedora release, and base-image flavor), based on item and type.
 
-    :param dict formula: parsed formula file (or dict with equivalent structure)
     :param dict arg_data: parsed command-line arguments. item, type and arch
                           are used in this method
+    :param bool match_host_arch: devise arch only when this param is True, otherwise
+                                 use default arch
     :return: dict containing distro, release, flavor, arch. Each either set, or None
     :raise TaskotronValueError: when environment can't be parsed from the formula
     '''
@@ -32,7 +34,7 @@ def devise_environment(arg_data):
     item = arg_data.get('item', None)
     item_type = arg_data.get('type', None)
 
-    if not env['distro']:
+    if playbook_data.match_host_distro:
         if item_type == 'koji_build':
             # FIXME: find a way to make this not Fedora-specific
             # For `xchat-2.8.8-21.fc20` disttag is `fc20` for example
@@ -52,8 +54,10 @@ def devise_environment(arg_data):
         else:
             log.debug("Environment/distro can not be inferred from %r:%r. Using default.",
                       item_type, item)
+    else:
+        log.debug('Variable taskotron_match_host_distro is set to False. Using default distro.')
 
-    if not env['release']:
+    if playbook_data.match_host_release:
         if item_type == 'koji_build':
             # FIXME: find a way to make this not Fedora-specific
             # Last two characters in rpm's disttag are the Fedora release.
@@ -73,16 +77,25 @@ def devise_environment(arg_data):
         else:
             log.debug("Environment/release can not be inferred from %r:%r. Using default.",
                       item_type, item)
+    else:
+        log.debug('Variable taskotron_match_host_release is set to False. Using default release.')
 
     if not env['flavor']:
         log.debug("Environment/flavor not specified. Using default")
 
-    if not env['arch']:
+    if playbook_data.match_host_arch:
         arch = arg_data.get('arch')
         if not arch or arch == 'noarch':
             log.warn("Environment/arch can not be inferred from %r. Using default.", arch)
         else:
             env['arch'] = arch
             log.debug("Environment/arch inferred from %r to %r", arch, env['arch'])
+    else:
+        log.debug('Variable taskotron_match_host_arch is set to False. Using default arch.')
+
+    env['distro'] = env['distro'] or config.get_config().default_disposable_distro
+    env['release'] = env['release'] or config.get_config().default_disposable_release
+    env['flavor'] = env['flavor'] or config.get_config().default_disposable_flavor
+    env['arch'] = env['arch'] or config.get_config().default_disposable_arch
 
     return env
diff --git a/testing/functest_executor.py b/testing/functest_executor.py
index 9428dd7..c71a79b 100644
--- a/testing/functest_executor.py
+++ b/testing/functest_executor.py
@@ -8,6 +8,7 @@
 import pytest
 import mock
 import signal
+import yaml
 
 from libtaskotron import executor
 import libtaskotron.exceptions as exc
@@ -71,7 +72,7 @@ class TestExecutor():
         # the tradeoff here is that we need to run with root=False
         # (non-default)
         output, _ = self.executor._run_playbook(self.playbook_name,
-            self.ipaddr, root=False)
+            self.ipaddr, executor.Playbook_Data(yaml.load(PLAYBOOK)[0]), root=False)
         # FIXME: We currently have no idea whether the test playbook passed
         # or failed, because we ignore the inner playbook's exit status. So
         # we can't really verify here whether everything worked ok.
diff --git a/testing/test_executor.py b/testing/test_executor.py
index 8f75692..a5dfbfe 100644
--- a/testing/test_executor.py
+++ b/testing/test_executor.py
@@ -11,6 +11,7 @@ import signal
 import os
 import json
 import subprocess
+import yaml
 
 from libtaskotron import executor
 import libtaskotron.exceptions as exc
@@ -39,6 +40,7 @@ PLAYBOOK_STI='''
         msg: This is a sample debug printout from an STI task
 '''
 
+PLAYBOOK_DATA=executor.Playbook_Data(yaml.load(PLAYBOOK)[0])
 
 @pytest.mark.usefixtures('setup')
 class TestExecutor():
@@ -127,7 +129,7 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         output, _ = self.executor._run_playbook(self.playbook_name,
-            self.ipaddr)
+            self.ipaddr, PLAYBOOK_DATA)
 
         # must return playbook output
         assert output == 'fake output'
@@ -170,7 +172,8 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         with pytest.raises(exc.TaskotronError):
-            self.executor._run_playbook(self.playbook_name, self.ipaddr)
+            self.executor._run_playbook(self.playbook_name, self.ipaddr, 
+                PLAYBOOK_DATA)
 
         # must unmask signals even when playbook failed
         assert mock_signal.call_count == 4  # 2 signals masked, then reset
@@ -190,7 +193,8 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         with pytest.raises(exc.TaskotronInterruptError):
-            self.executor._run_playbook(self.playbook_name, self.ipaddr)
+            self.executor._run_playbook(self.playbook_name, self.ipaddr, 
+                PLAYBOOK_DATA)
 
         # must unmask signals even when playbook failed
         assert mock_signal.call_count == 4  # 2 signals masked, then reset
@@ -213,7 +217,8 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         with pytest.raises(exc.TaskotronInterruptError):
-            self.executor._run_playbook(self.playbook_name, self.ipaddr)
+            self.executor._run_playbook(self.playbook_name, self.ipaddr,
+                PLAYBOOK_DATA)
 
     def test_execute_local(self, monkeypatch):
         '''Execution using local mode'''
@@ -416,7 +421,7 @@ class TestExecutor():
         vm_instance.ipaddr = '10.11.12.13'
         monkeypatch.setattr(vm, 'TestCloudMachine', mock_vm)
 
-        ipaddr = self.executor._spawn_vm(None)
+        ipaddr = self.executor._spawn_vm(None, PLAYBOOK_DATA)
         assert ipaddr == '10.11.12.13'
         assert mock_vm_prepare.call_count == 2
 
@@ -428,6 +433,6 @@ class TestExecutor():
         monkeypatch.setattr(vm, 'TestCloudMachine', mock_vm)
 
         with pytest.raises(exc.TaskotronMinionError):
-            self.executor._spawn_vm(None)
+            self.executor._spawn_vm(None, PLAYBOOK_DATA)
 
         assert mock_vm_prepare.call_count == self.conf.spawn_vm_retries
diff --git a/testing/test_image_utils.py b/testing/test_image_utils.py
index 82b9bbb..f785dec 100644
--- a/testing/test_image_utils.py
+++ b/testing/test_image_utils.py
@@ -6,6 +6,8 @@
 '''Unit tests for libtaskotron/image_utils.py'''
 
 from libtaskotron.image_utils import devise_environment
+from libtaskotron.executor import Playbook_Data
+from libtaskotron import config
 
 class TestDeviseEnvironment:
 
@@ -15,12 +17,19 @@ class TestDeviseEnvironment:
             'type': 'koji_build',
             'arch': 'noarch',
         }
+        self.playbook_data = Playbook_Data({
+            'vars': {
+                'taskotron_match_host_distro': True,
+                'taskotron_match_host_release': True,
+                'taskotron_match_host_arch': False
+            }
+        })
 
     def test_koji_build(self):
-        env = devise_environment(self.arg_data)
+        env = devise_environment(self.arg_data, self.playbook_data)
         assert env['distro'] == 'fedora'
         assert env['release'] == '27'
-        assert env['arch'] == None
+        assert env['arch'] == config.get_config().default_disposable_arch
 
     def test_koji_tag(self):
         self.arg_data = {
@@ -28,13 +37,38 @@ class TestDeviseEnvironment:
             'type': 'koji_tag',
             'arch': 'x86_64',
         }
-        env = devise_environment(self.arg_data)
+        self.playbook_data.match_host_arch = True
+        env = devise_environment(self.arg_data, self.playbook_data)
         assert env['distro'] == 'fedora'
         assert env['release'] == '27'
         assert env['arch'] == self.arg_data['arch']
 
     def test_unknown_distro(self):
         self.arg_data['item'] = 'htop-2.0.2-4.el7'
-        env = devise_environment(self.arg_data)
-        assert env['distro'] == None
-        assert env['release'] == None
+        env = devise_environment(self.arg_data, self.playbook_data)
+        assert env['distro'] == config.get_config().default_disposable_distro
+        assert env['release'] == config.get_config().default_disposable_release
+
+    def test_match_host_arch_true(self):
+        self.arg_data = {
+            'item': 'htop-2.0.2-4.fc27',
+            'type': 'koji_build',
+            'arch': 'armhfp',
+        }
+        self.playbook_data.match_host_arch = True
+        env = devise_environment(self.arg_data, self.playbook_data)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == '27'
+        assert env['arch'] == 'armhfp'
+
+    def test_match_host_arch_false(self):
+        self.arg_data = {
+            'item': 'htop-2.0.2-4.fc27',
+            'type': 'koji_build',
+            'arch': 'armhfp',
+        }
+        self.playbook_data.match_host_arch = False
+        env = devise_environment(self.arg_data, self.playbook_data)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == '27'
+        assert env['arch'] == config.get_config().default_disposable_arch

